#---------------------------------------------------------------
# Image Editor
#----------------------------------------------------------------

#
# Configurations

set c(ImageEditorList) {
    { XV          xv      }
    { ImageMagic  display }
    { GIMP        gimp    }
}
set c(ImageEditor) XV

# ImageEditorWinmode: 0=in one window, 1=separate window
set c(ImageEditorWinmode) 1

foreach i $c(ImageEditorList) { set c([lindex $i 0]command) [lindex $i 1] }

#
# window_ImageEditor and make_ImageEditor

proc window_ImageEditor { wn } {
    setcur Default
}

proc make_ImageEditor { prefix i } { global s c
    set ImageEditor $c($c(ImageEditor)command)
    if {$c(ImageEditorWinmode) == 1 || $s(nrect) == 0} {
        set geometry "-geometry [format "+%d+%d" [expr $i*100] [expr $i*25]]"
        set file "$c(tkscandir)/$prefix-$i.pnm"
    } else {
        if {$i < $s(nrect)} {return}
        set geometry "-geometry +0+0"
        for {set files ""; set j 1} {$j <= $s(nrect)} {incr j} {
            append file " $c(tkscandir)/$prefix-$j.pnm"
        }
    }
    if {$s(gamma_support)==1} {
        switch $ImageEditor {
            xv { set gamma "-gamma $s(gamma) \
                -cgamma $s(gamma_red) $s(gamma_green) $s(gamma_blue)"
            }
            display {
                set gamma "-gamma $s(gamma_red),$s(gamma_green),$s(gamma_blue)"
            }
            gimp {
            }
        }
    } else { set gamma "" }
    exec sh -c \
        "$ImageEditor $geometry $gamma $file ; \
         rm -f $file" &
    stat_text "Scanning $s(curscan) / $s(nrect) ... sent to $ImageEditor"
    update
}

#
# Subroutines

proc setImageEditor { i } { global s c w
    set c(ImageEditor) $i
    set c(ImageEditor) $i
#   $w(outtype) configure -text [arrayel $c(ImageEditorList) $i 0]
}

